## uhd 4.9.0.0+ds1

=== host/CMakeLists.txt ===
#
# Copyright 2010-2018 Ettus Research, a National Instruments Company
# Copyright 2019 Ettus Research, a National Instruments Brand
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

# NOTE! If you change the version in the following line, also change
# UHD_CMAKE_MIN_VERSION in UHDMinDepVersions. (This won't take a variable).
cmake_minimum_required(VERSION 3.12)
if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW) # Suppress Version warnings
endif(POLICY CMP0048)

########################################################################
# Select cmake build type
# Use release build type by default to get optimization flags
# Do this before project setup to ensure dependend libraries use
# the correct build type for library search.
########################################################################
if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
   message(STATUS "Build type not specified: defaulting to release.")
endif(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING "")

# Force UHD_RELEASE_MODE to be a string for cmake-gui
set(UHD_RELEASE_MODE "${UHD_RELEASE_MODE}" CACHE STRING "UHD Release Mode")


########################################################################
# Project setup
########################################################################
# Backup custom UHD_VERSION if defined by using option -DUHD_VERSION=...,
# because project() will reset it to an empty string.
if(UHD_VERSION)
   set(CUSTOM_UHD_VERSION "${UHD_VERSION}")
endif(UHD_VERSION)

# Note: if UHD_VERSION is not defined, project() will leave it undefined
# for cmake version < 4.1.0, but set it to an empty string for cmake
# version >= 4.1.0.
project(UHD CXX C)

# Restore the custom UHD_VERSION if it was defined before project()
if(DEFINED CUSTOM_UHD_VERSION)
   set(UHD_VERSION "${CUSTOM_UHD_VERSION}" CACHE STRING "" FORCE)
endif(DEFINED CUSTOM_UHD_VERSION)

enable_testing()

# Make sure our local CMake Modules path comes first
list(INSERT CMAKE_MODULE_PATH 0 ${UHD_SOURCE_DIR}/cmake/Modules)


########################################################################
# UHD Dependency Minimum Versions are stored in a separate file
########################################################################
include(UHDMinDepVersions)


########################################################################
# Check Compiler Version
########################################################################
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    if(DEFINED CMAKE_CXX_COMPILER_VERSION)
        if(${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS ${UHD_GCC_MIN_VERSION})
            message(WARNING
              "\nThe compiler selected to build UHD "
              "(GCC version ${CMAKE_CXX_COMPILER_VERSION} : ${CMAKE_CXX_COMPILER}) "
              "is older than that officially supported (${UHD_GCC_MIN_VERSION} minimum). "
              "This build may or not work. "
              "We highly recommend using a more recent GCC version.")
         endif()
    else()
        message(WARNING
          "\nCannot determine the version of the compiler selected to build UHD "
          "(GCC : ${CMAKE_CXX_COMPILER}). This build may or not work. We highly "
          "recommend using GCC version ${UHD_GCC_MIN_VERSION} or more recent.")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Og")
elseif(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    execute_process(COMMAND
        ${CMAKE_CXX_COMPILER} -v
        RESULT_VARIABLE res ERROR_VARIABLE err
        ERROR_STRIP_TRAILING_WHITESPACE)
    if(${res} STREQUAL "0")
        # Version output is in error stream
        string(REGEX MATCH "^Apple.*" IS_APPLE ${err})

        # Retrieve the compiler's version
        if("${IS_APPLE}" STREQUAL "")
            set(MIN_VERSION ${UHD_CLANG_MIN_VERSION})
            set(APPLE_STR "")
            string(REGEX MATCH "clang version [0-9.]+" CLANG_OTHER_VERSION ${err})
            string(REGEX MATCH "[0-9.]+" CLANG_VERSION ${CLANG_OTHER_VERSION})
        else()
            set(MIN_VERSION ${UHD_APPLECLANG_MIN_VERSION})
            set(APPLE_STR "Apple ")
            string(REGEX MATCH "(clang-[0-9.]+)" CLANG_APPLE_VERSION ${err})
            string(REGEX MATCH "[0-9.]+" CLANG_VERSION ${CLANG_APPLE_VERSION})
        endif()

        if(${CLANG_VERSION} VERSION_LESS "${MIN_VERSION}")
            message(WARNING
              "\nThe compiler selected to build UHD "
              "(${APPLE_STR}Clang version ${CLANG_VERSION} : ${CMAKE_CXX_COMPILER}) "
              "is older than that officially supported (${MIN_VERSION} minimum). "
              "This build may or not work. We highly recommend using Apple Clang "
              "version ${UHD_APPLECLANG_MIN_VERSION} or more recent, "
              "or Clang version ${UHD_CLANG_MIN_VERSION} or more recent.")
        endif()
    else()
        message(WARNING
          "\nCannot determine the version of the compiler selected to build UHD "
          "(${APPLE_STR}Clang : ${CMAKE_CXX_COMPILER}). This build may or not work. "
          "We highly recommend using Apple Clang version ${UHD_APPLECLANG_MIN_VERSION} "
          "or more recent, or Clang version ${UHD_CLANG_MIN_VERSION} or more recent.")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Og")
elseif(MSVC)
    if(${MSVC_VERSION} VERSION_LESS ${UHD_MSVC_MIN_VERSION})
	message(FATAL_ERROR
          "\nMSVC version is less than the required minimum. "
          "Required: ${UHD_MSVC_MIN_VERSION_READABLE}")
    endif(${MSVC_VERSION} VERSION_LESS ${UHD_MSVC_MIN_VERSION})
endif()

set(CMAKE_CXX_STANDARD 17)

if(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" AND ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_EXE_LINKER_FLAGS "-lthr ${CMAKE_EXE_LINKER_FLAGS}")
    set(CMAKE_CXX_FLAGS "-stdlib=libc++ ${CMAKE_CXX_FLAGS}")
endif()


########################################################################
# Packaging Variables
########################################################################
option(UNDERSCORE_UHD_VERSION "Replace dashes in uhd version with underscores" OFF)
set(LIBUHD_PKG ${LIBUHD_PKG} CACHE BOOL "Build Debian libuhd003 package")
set(LIBUHDDEV_PKG ${LIBUHDDEV_PKG} CACHE BOOL "Build Debian libuhd-dev package")
set(UHDHOST_PKG ${UHDPOST_PKG} CACHE BOOL "Build Debian uhd-host package")
include(UHDComponent) #enable components
include(UHDPackage)   #setup cpack


########################################################################
# Install Dirs
########################################################################
include(GNUInstallDirs)

set(PKG_DATA_DIR ${CMAKE_INSTALL_DATAROOTDIR}/uhd)
if(NOT DEFINED PKG_LIB_DIR)
    set(PKG_LIB_DIR ${CMAKE_INSTALL_LIBDIR}/uhd)
endif()
if(NOT DEFINED PKG_DOC_DIR)
    # Note: CMAKE_INSTALL_DOCDIR would go to share/doc/UHD (capitalized) because
    # that's what the project name is, but we want to keep it lowercase.
    string(TOLOWER "${CMAKE_INSTALL_DOCDIR}" PKG_DOC_DIR)
endif()
set(PKG_MAN_DIR ${CMAKE_INSTALL_MANDIR}/man1)


########################################################################
# UHD config files
########################################################################
set(UHD_USER_CONF_FILE
    "uhd.conf"
    CACHE STRING
    "Location of the user-specific UHD configuration file, relative to APPDATA (or XDG_CONFIG_HOME)"
)
if(UNIX)
    set(UHD_SYS_CONF_FILE
        "/etc/uhd/uhd.conf"
        CACHE STRING
        "Location of the system-wide UHD configuration file"
    )
elseif(WIN32)
    set(UHD_SYS_CONF_FILE
        "%programdata%/uhd/uhd.conf"
        CACHE STRING
        "Location of the system-wide UHD configuration file"
    )
else()
    message(WARNING "Not setting UHD_SYS_CONF_FILE!")
endif()


########################################################################
# UHD Image Directories
########################################################################
if(NOT DEFINED UHD_IMAGES_DIR)
    if(DEFINED FPGA_IMAGES_DIR)
        set(UHD_IMAGES_DIR ${FPGA_IMAGES_DIR})
    else(DEFINED FPGA_IMAGES_DIR)
        file(TO_NATIVE_PATH ${CMAKE_INSTALL_PREFIX}/share/uhd/images using_images_dir)
        set(UHD_IMAGES_DIR ${using_images_dir})
    endif(DEFINED FPGA_IMAGES_DIR)
endif(NOT DEFINED UHD_IMAGES_DIR)

message( STATUS "Using UHD Images Directory: ${UHD_IMAGES_DIR}" )

if(DEFINED UHD_IMAGES_DIR_WINREG_KEY)
    add_definitions(-DUHD_IMAGES_DIR_WINREG_KEY=${UHD_IMAGES_DIR_WINREG_KEY})
endif(DEFINED UHD_IMAGES_DIR_WINREG_KEY)


########################################################################
# Local Include Dir
########################################################################
include_directories(${UHD_BINARY_DIR}/include)
include_directories(${UHD_SOURCE_DIR}/include)


########################################################################
# Static Lib Configuration
########################################################################
option(ENABLE_STATIC_LIBS "Enable building of static libraries" OFF)
if(ENABLE_STATIC_LIBS)
    message(STATUS "Building Static Libraries: ${ENABLE_STATIC_LIBS}")
endif(ENABLE_STATIC_LIBS)


########################################################################
# On Apple only, set install name and rpath correctly if not already set
########################################################################
if(APPLE)
    if(NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR ${CMAKE_INSTALL_FULL_LIBDIR} CACHE
            PATH "Library Install Name Destination Directory" FORCE)
    endif(NOT CMAKE_INSTALL_NAME_DIR)
    if(NOT CMAKE_INSTALL_RPATH)
        set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR} CACHE
            PATH "Library Install RPath" FORCE)
    endif(NOT CMAKE_INSTALL_RPATH)
    if(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
        set(CMAKE_BUILD_WITH_INSTALL_RPATH ON CACHE
            BOOL "Do Build Using Library Install RPath" FORCE)
        set(CMAKE_BUILD_WITH_INSTALL_NAME_DIR ON CACHE
            BOOL "Set install name to install name dir during build" FORCE)
    endif(NOT CMAKE_BUILD_WITH_INSTALL_RPATH)
endif(APPLE)


########################################################################
# Optional Compiler Flags
########################################################################
include(CheckCXXCompilerFlag)
macro(UHD_ADD_OPTIONAL_CXX_COMPILER_FLAG flag have)
    CHECK_CXX_COMPILER_FLAG(${flag} ${have})
    if(${have})
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
    endif(${have})
endmacro(UHD_ADD_OPTIONAL_CXX_COMPILER_FLAG)

if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU" OR
    ${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    if(STRIP_BINARIES)
        if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -s")
        endif(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    endif(STRIP_BINARIES)
    add_definitions(-Wall)
    add_definitions(-Wextra)
    add_definitions(-Wsign-compare)
    #add_definitions(-Wconversion)
    #add_definitions(-pedantic)
    #add_definitions(-ansi)
    if(NOT WIN32)
        # Only export symbols that are declared to be part of the uhd api (non dll platforms)
        UHD_ADD_OPTIONAL_CXX_COMPILER_FLAG(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN)
        UHD_ADD_OPTIONAL_CXX_COMPILER_FLAG(-fvisibility-inlines-hidden HAVE_VISIBILITY_INLINES_HIDDEN)
    endif(NOT WIN32)
    if(${CMAKE_BUILD_TYPE} STREQUAL "Coverage")
        include(CodeCoverage)
        # Never fail ctest, always generate coverage report
        setup_target_for_coverage(coverage "ctest || return 0" coverage)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic -pthread -g -O0 -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used by the C++ compiler during Coverage builds." FORCE)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -pthread -g -O0 -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used by the C compiler during Coverage builds." FORCE)
    endif()
endif()

if(MSVC)
    include_directories(${UHD_SOURCE_DIR}/cmake/msvc)

=== mpm/CMakeLists.txt ===
#
# Copyright 2017-2018 Ettus Research, a National Instruments Company
# Copyright 2019 Ettus Research, a National Instruments Brand
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

cmake_minimum_required(VERSION 3.12)
project(MPM C CXX) # Also has Python, but CMake can take care of that later
# Set the default value for CMAKE_INSTALL_PREFIX to /usr
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr"
        CACHE
        PATH
        "Default installation path for MPM"
        FORCE
    )
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)
set(UHD_SOURCE_DIR ${CMAKE_SOURCE_DIR}/../host)
list(INSERT CMAKE_MODULE_PATH 0 ${UHD_SOURCE_DIR}/cmake/Modules)
########################################################################
# Setup Python API
########################################################################

# We don't need to support older versions of Python, since we will always
# deploy this on devices where we control the Python version.
# MPM might work with future versions of Python, but we make no guarantees.
set(UHD_PYTHON_MIN_VERSION    "3.7" )
set(UHD_PYBIND11_MIN_VERSION  "2.7" )

# search the Python interpreter, modules and include directories
include(UHDPython)

########################################################################
# Find Python Modules
########################################################################
UHD_PYTHON_CHECK_MODULE_VERSION(
    "Mako templates"
    "mako"
    "mako.__version__"
    "0.4.2"
    HAVE_PYTHON_MODULE_MAKO
)

########################################################################
# Version Information
########################################################################
include(MPMVersion)

########################################################################
# useful macros
########################################################################
include(MPMComponent) # enable components

macro(USRP_PERIPHS_APPEND_SOURCES)
    set(usrp_periphs_sources ${usrp_periphs_sources} PARENT_SCOPE)
    list(APPEND usrp_periphs_sources ${ARGV})
endmacro(USRP_PERIPHS_APPEND_SOURCES)

macro(USRP_PERIPHS_APPEND_OBJECTS)
    set(usrp_periphs_objects ${usrp_periphs_objects} PARENT_SCOPE)
    foreach(arg ${ARGV})
        list(APPEND usrp_periphs_objects $<TARGET_OBJECTS:${arg}>)
    endforeach(arg)
    set(usrp_periphs_objects ${usrp_periphs_objects} PARENT_SCOPE)
endmacro(USRP_PERIPHS_APPEND_OBJECTS)

macro(USRP_PERIPHS_ADD_OBJECT name)
  add_library(${name} OBJECT ${ARGN})
  set_property(TARGET ${name} PROPERTY POSITION_INDEPENDENT_CODE ON)
  USRP_PERIPHS_APPEND_OBJECTS(${name})
endmacro(USRP_PERIPHS_ADD_OBJECT)

########################################################################
# Setup Boost
########################################################################
# Note: We can keep this short, because, again, we control the build
# environment. This will not, out of the box, compile on Windows or
# other platforms.
message(STATUS "")
message(STATUS "Configuring Boost C++ Libraries...")
set(BOOST_REQUIRED_COMPONENTS
    system
    thread
    date_time
)
# Same as with Python version: MPM might work with other versions of Boost,
# but we don't make any guarantees.
set(MPM_BOOST_VERSION "1.66")

# This variable is a helper for the find_package() command below, and only
# takes effect if the build is happening on a system where the FindBoost.cmake
# file is older than ${MPM_BOOST_VERSION}, which is usually not the case.
set(Boost_ADDITIONAL_VERSIONS ${MPM_BOOST_VERSION})
find_package(Boost ${MPM_BOOST_VERSION} COMPONENTS ${BOOST_REQUIRED_COMPONENTS})

include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

message(STATUS "Boost include directories: ${Boost_INCLUDE_DIRS}")
message(STATUS "Boost library directories: ${Boost_LIBRARY_DIRS}")
message(STATUS "Boost libraries: ${Boost_LIBRARIES}")


########################################################################
# Install Dirs
########################################################################
include(GNUInstallDirs)

########################################################################
# Setup library configuration
########################################################################
set(CMAKE_CXX_STANDARD 14)
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wno-psabi" _has_no_psabi)
# -Wno-psabi lets us know if the gcc ABI changed and would cause binaries
# to have different ABIs. We don't care, since we compile the entire
# system with the same gcc. These warnings are also noisy.
if(_has_no_psabi)
    message(STATUS "Disabling psABI warnings.")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif(_has_no_psabi)
set(MPM_ALL_DEVICES n3xx e320 e31x x4xx sim tests)
set(MPM_DEVICE "n3xx" CACHE STRING "Choose an MPM device to build")
set_property(CACHE MPM_DEVICE PROPERTY STRINGS ${MPM_ALL_DEVICES})
# Validate MPM_DEVICE
list(FIND MPM_ALL_DEVICES ${MPM_DEVICE} mpm_device_check)
if(mpm_device_check EQUAL -1)
    message(FATAL_ERROR "MPM_DEVICE must be one of ${MPM_ALL_DEVICES}! \
        Specify -DMPM_DEVICE=<device> on the command line or set MPM_DEVICE using a CMake GUI.")
endif()

# Request required components for MPM_DEVICE
if(MPM_DEVICE STREQUAL "n3xx")
    set(ENABLE_MYKONOS ON)
    set(ENABLE_MAGNESIUM ON)
elseif(MPM_DEVICE STREQUAL "e320")
    set(ENABLE_E320 ON)
elseif(MPM_DEVICE STREQUAL "e31x")
    set(ENABLE_E300 ON)
elseif(MPM_DEVICE STREQUAL "x4xx")
    set(ENABLE_X400 ON)
    set(DEVICE_LIBRARIES "metal")
elseif(MPM_DEVICE STREQUAL "sim")
    set(ENABLE_SIM TRUE)
    set(ENABLE_LIBMPM OFF)
endif()

MPM_REGISTER_COMPONENT("LibMPM" ENABLE_LIBMPM ON "Boost_FOUND" OFF ON)
MPM_REGISTER_COMPONENT("RegMaps" ENABLE_REGMAPS ON "HAVE_PYTHON_MODULE_MAKO" OFF OFF)
MPM_REGISTER_COMPONENT("Mykonos" ENABLE_MYKONOS OFF "ENABLE_LIBMPM" OFF OFF)
MPM_REGISTER_COMPONENT("Magnesium" ENABLE_MAGNESIUM OFF "ENABLE_MYKONOS" OFF OFF)
MPM_REGISTER_COMPONENT("E320" ENABLE_E320 OFF "ENABLE_LIBMPM" OFF OFF)
MPM_REGISTER_COMPONENT("E300" ENABLE_E300 OFF "ENABLE_LIBMPM" OFF OFF)
MPM_REGISTER_COMPONENT("X400" ENABLE_X400 OFF "ENABLE_LIBMPM;ENABLE_REGMAPS" OFF OFF)

if(NOT ENABLE_SIM)
    add_subdirectory(include)
    include_directories(
        ${CMAKE_CURRENT_SOURCE_DIR}/include
        ${CMAKE_BINARY_DIR}/include
        ${UHD_SOURCE_DIR}/include
    )

    add_subdirectory(lib)

    message("usrp_periphs objects: ${usrp_periphs_objects}")
    add_library(usrp-periphs SHARED ${usrp_periphs_objects})
    target_link_libraries(usrp-periphs
        udev
        ${Boost_LIBRARIES}
        ${DEVICE_LIBRARIES}
    )

    install(TARGETS usrp-periphs LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries)

    # TODO: Come up with a versioning scheme for the MPM ABI. Not high priority
    # though... we're the only ones linking against that.
    set_target_properties(usrp-periphs PROPERTIES VERSION "${MPM_VERSION_MAJOR}.${MPM_VERSION_API}.${MPM_VERSION_ABI}")
    set_target_properties(usrp-periphs PROPERTIES SOVERSION ${MPM_VERSION_MAJOR})

    add_subdirectory(systemd)
    add_subdirectory(tools)
endif(NOT ENABLE_SIM)

enable_testing()
add_subdirectory(python)



########################################################################
# Print Summary
########################################################################
if(MPM_VERSION_DEVEL AND NOT MPM_GIT_BRANCH STREQUAL "maint")
    message(STATUS "******************************************************")
    if(MPM_GIT_BRANCH STREQUAL "master")
        message(STATUS "* You are building the UHD development master branch.")
        message(STATUS "* For production code, we recommend our stable,")
        message(STATUS "* releases or using the release branch (maint).")
    else()
        message(STATUS "* You are building a development branch of UHD.")
        message(STATUS "* These branches are designed to provide early access")
        message(STATUS "* to UHD and USRP features, but should be considered")
        message(STATUS "* unstable and/or experimental!")
    endif(MPM_GIT_BRANCH STREQUAL "master")
    message(STATUS "******************************************************")
endif(MPM_VERSION_DEVEL AND NOT MPM_GIT_BRANCH STREQUAL "maint")
message(STATUS "Building version: ${MPM_VERSION}")
message(STATUS "Building for device: ${MPM_DEVICE}")

=== .ci/utils/requirements.txt ===
labgrid==24.0.3
fabric==3.2.2
pyroute2==0.8.1
pottery==3.0.0
py3tftp==1.3.0

=== firmware/fx2/CMakeLists.txt ===
#
# Copyright 2010 Ettus Research LLC
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 2.6)
set(CMAKE_TOOLCHAIN_FILE ${CMAKE_SOURCE_DIR}/config/Toolchain-sdcc.cmake)
project(USRP1 C)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/config/")
include(FindPythonInterp)

########################################################################
# Set toolchain to use SDCC
########################################################################
# we're doing mixed ASM and C
enable_language(ASM_SDCC)

########################################################################
# C flags and linking flags
########################################################################
add_definitions(-DHAVE_USRP2)
set(CMAKE_C_LINK_FLAGS "--code-loc 0x0000 --code-size 0x1800 --xram-loc 0x1800 --xram-size 0x0800 -Wl '-b USBDESCSEG = 0xE000'")
set(CMAKE_C_FLAGS "--no-xinit-opt")

########################################################################
# Setup precompile tools
########################################################################
set(REG_GENERATOR ${CMAKE_SOURCE_DIR}/utils/generate_regs.py)
set(EDIT_GPIF_USRP1 ${CMAKE_SOURCE_DIR}/utils/edit-gpif.py)
set(EDIT_GPIF_B100 ${CMAKE_SOURCE_DIR}/utils/edit-gpif-b100.py)
set(BUILD_EEPROM ${CMAKE_SOURCE_DIR}/utils/build_eeprom.py)

########################################################################
# Add the subdirectories
########################################################################
add_subdirectory(usrp1)
add_subdirectory(b100)

=== firmware/octoclock/CMakeLists.txt ===
#
# Copyright 2014 Ettus Research LLC
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 2.6)
set(CMAKE_SYSTEM_NAME Generic)

find_program(AVR_CC avr-gcc REQUIRED)
find_program(AVR_OBJCOPY avr-objcopy REQUIRED)
find_program(AVRDUDE avrdude REQUIRED)
set(CMAKE_C_COMPILER ${AVR_CC})

project(OCTOCLOCK C)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mmcu=atmega128 -std=gnu99")

if(NOT DEFINED PROGRAMMER)
    set(PROGRAMMER "avrisp2")
endif(NOT DEFINED PROGRAMMER)

if(OCTOCLOCK_DEBUG)
    message(STATUS "Debug enabled.")
    add_definitions(-DDEBUG)
endif(OCTOCLOCK_DEBUG)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/../../host/lib/usrp_clock
)

add_subdirectory(bootloader)
add_subdirectory(lib)
add_subdirectory(octoclock_r4)

=== fpga/docs/Makefile ===
#
# Copyright 2015 Ettus Research LLC
#

manual:
	doxygen Doxyfile

clean:
	@rm -rf html
	@rm -rf latex
	@rm -rf *.db

.PHONY: manual clean

=== host/docs/CMakeLists.txt ===
#
# Copyright 2010-2013,2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
# Copyright 2019 Ettus Research, a National Instruments Brand
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# List of manual sources
########################################################################

########################################################################
# Setup general Doxygen variables
########################################################################
find_package(Doxygen)
set(ENABLE_MANUAL_OR_DOXYGEN false)

########################################################################
# Setup Manual (using Doxygen)
########################################################################
LIBUHD_REGISTER_COMPONENT("Manual" ENABLE_MANUAL ON "DOXYGEN_FOUND" OFF OFF)

if(ENABLE_MANUAL)
    set(FPGA_SOURCE_DIR "${UHD_SOURCE_DIR}/../fpga")
    set(ENABLE_MANUAL_OR_DOXYGEN true)
    file(GLOB manual_sources "*.dox")
    file(GLOB_RECURSE fpga_manual_sources "${FPGA_SOURCE_DIR}/docs/*.md")
    list(APPEND manual_sources ${fpga_manual_sources})
    set(DOXYGEN_DEPENDENCIES ${manual_sources})
    set(DOXYGEN_INPUT_DIRS "${UHD_SOURCE_DIR}/docs ${CMAKE_CURRENT_BINARY_DIR} ${FPGA_SOURCE_DIR}/docs")
    set(DOXYGEN_DEP_COMPONENT "manual")
    set(DOXYGEN_FPGA_MANUAL_REFERENCE "\\subpage md_fpga \"Part III: FPGA Manual\"")
    set(DOXYGEN_STRIP_EXTRA "${UHD_SOURCE_DIR}/../fpga/docs")
    set(DOXYGEN_EXCLUDE_DIRS "")
endif(ENABLE_MANUAL)

########################################################################
# Setup API documentation (using Doxygen)
########################################################################
LIBUHD_REGISTER_COMPONENT("API/Doxygen" ENABLE_DOXYGEN ON "DOXYGEN_FOUND" OFF OFF)
option(ENABLE_DOXYGEN_FULL "Use Doxygen to document the entire source tree (not just API)" OFF)
option(ENABLE_DOXYGEN_DOT "Let Doxygen use dot (requires graphviz)" OFF)
option(ENABLE_DOXYGEN_SHORTNAMES "Let Doxygen use shorter filenames (helps on Windows)" OFF)
set(
    MATHJAX_RELPATH https://cdn.jsdelivr.net/npm/mathjax@2/
    CACHE STRING "MATHJAX_RELPATH option for Doxygen")
mark_as_advanced(MATHJAX_RELPATH)

if(LIBUHDDEV_PKG)
    set(PKG_DOC_DIR share/doc/libuhd-dev)
endif(LIBUHDDEV_PKG)

if(ENABLE_DOXYGEN)
    set(ENABLE_MANUAL_OR_DOXYGEN true)
    #make doxygen directory depend on the header files
    file(GLOB_RECURSE header_files ${UHD_SOURCE_DIR}/include/*.hpp)
    file(GLOB_RECURSE h_files ${UHD_SOURCE_DIR}/include/*.h)
    list(APPEND header_files ${h_files})
    set(DOXYGEN_DEPENDENCIES ${DOXYGEN_DEPENDENCIES} ${header_files})
    if(ENABLE_DOXYGEN_FULL)
        set(DOXYGEN_INPUT_DIRS "${DOXYGEN_INPUT_DIRS} ${UHD_SOURCE_DIR}/include ${UHD_SOURCE_DIR}/lib ${UHD_SOURCE_DIR}/python")
    else(ENABLE_DOXYGEN_FULL)
        set(DOXYGEN_INPUT_DIRS "${DOXYGEN_INPUT_DIRS} ${UHD_SOURCE_DIR}/include")
    endif(ENABLE_DOXYGEN_FULL)

    set(DOXYGEN_DEP_COMPONENT "doxygen")
endif(ENABLE_DOXYGEN)

########################################################################
# Run Doxygen (on code and/or manual, depending on CMake flags)
########################################################################
if(ENABLE_MANUAL_OR_DOXYGEN)
    #generate the doxygen configuration file
    set(CMAKE_CURRENT_BINARY_DIR_DOXYGEN ${CMAKE_CURRENT_BINARY_DIR}/doxygen)
    if(ENABLE_DOXYGEN_DOT)
        set(DOXYGEN_HAVE_DOT "YES")
    else(ENABLE_DOXYGEN_DOT)
        set(DOXYGEN_HAVE_DOT "NO")
    endif(ENABLE_DOXYGEN_DOT)
    if(ENABLE_DOXYGEN_SHORTNAMES)
        set(DOXYGEN_SHORT_NAMES "YES")
    else(ENABLE_DOXYGEN_SHORTNAMES)
        set(DOXYGEN_SHORT_NAMES "NO")
    endif(ENABLE_DOXYGEN_SHORTNAMES)

    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
        ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/build.dox.in
        ${CMAKE_CURRENT_BINARY_DIR}/build.dox
    @ONLY)

    #make doxygen directory depend on the header files
    file(GLOB_RECURSE header_files ${UHD_SOURCE_DIR}/include/*.hpp)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR_DOXYGEN} DEPENDS ${DOXYGEN_DEPENDENCIES}
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        COMMENT "Generating documentation with doxygen"
    )

    #make the doxygen generation a built-time dependency
    add_custom_target(doxygen_docs ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR_DOXYGEN})
    UHD_INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR_DOXYGEN} DESTINATION ${PKG_DOC_DIR} COMPONENT ${DOXYGEN_DEP_COMPONENT})
endif(ENABLE_MANUAL_OR_DOXYGEN)

########################################################################
# List of man page sources
########################################################################

set(man_page_sources
    uhd_adc_self_cal.1
    uhd_cal_rx_iq_balance.1
    uhd_cal_tx_dc_offset.1
    uhd_cal_tx_iq_balance.1
    uhd_config_info.1
    uhd_find_devices.1
    uhd_image_loader.1
    uhd_images_downloader.1
    uhd_usrp_probe.1
    usrp_n2xx_simple_net_burner.1
    usrp2_card_burner.1
    rfnoc_modtool.1
    rfnoc_image_builder.1
)

if (ENABLE_PYTHON_API)
    list(APPEND man_page_sources
        usrpctl.1
    )
endif(ENABLE_PYTHON_API)

########################################################################
# Setup man pages
########################################################################
# No elegant way in CMake to reverse a boolean
if(NOT WIN32)
    set(NOT_WIN32 TRUE)
endif(NOT WIN32)

set(MAN_PAGES_DEPS "NOT_WIN32")

# Quietly see if we have GZip, if not, we can skip trying to compress
# the man pages
find_package(GZip QUIET)
set(ENABLE_MAN_PAGE_COMPRESSION ${GZIP_FOUND} CACHE BOOL "Compress Man Pages")

message(STATUS "")
if(ENABLE_MAN_PAGE_COMPRESSION)
    # If gzip is not found, this will force failure in
    # LIBUHD_REGISTER_COMPONENT for ENABLE_MAN_PAGES
    list(APPEND MAN_PAGES_DEPS "GZIP_FOUND")
    if(GZIP_FOUND)
        message(STATUS "Found GZip: ${GZIP_EXECUTABLE}")
        message(STATUS "")
        message(STATUS "Compressed Man Pages enabled")
    else()
        message(FATAL_ERROR
                "ENABLE_MAN_PAGE_COMPRESSION is set, "
                "but GZip compression program not found!")
        message(STATUS "")
    endif()
else()
    message(STATUS "Compressed Man Pages disabled")
endif(ENABLE_MAN_PAGE_COMPRESSION)
message(STATUS "  Override with -DENABLE_MAN_PAGE_COMPRESSION=ON/OFF")

LIBUHD_REGISTER_COMPONENT("Man Pages" ENABLE_MAN_PAGES ON "${MAN_PAGES_DEPS}" OFF OFF)
if(ENABLE_MAN_PAGES)
    #Generate man pages; either compressed or not
    if(ENABLE_MAN_PAGE_COMPRESSION)
        # compress man pages
        foreach(manfile ${man_page_sources})
            #make the gzip file depend on the text file
            string(REPLACE ".1" "" PROGRAM_NAME "${manfile}")
            set(gzfile "${CMAKE_CURRENT_BINARY_DIR}/${manfile}.gz")
            set(manfile "${CMAKE_CURRENT_SOURCE_DIR}/${manfile}")
            add_custom_command(
                OUTPUT ${gzfile}
                DEPENDS ${manfile}
                COMMAND ${GZIP_EXECUTABLE} -9 -cf ${manfile} > ${gzfile}
                COMMENT "Generating ${PROGRAM_NAME} man page"
            )
            #make the man page target depend on the gz file
            list(APPEND man_page_gz_files ${gzfile})
        endforeach(manfile ${man_page_sources})
        #make the man pages a build-time dependency
        UHD_INSTALL(FILES ${man_page_gz_files} DESTINATION ${PKG_MAN_DIR} COMPONENT manpages)
        add_custom_target(man_page_gzips ALL DEPENDS ${man_page_gz_files})
    else(ENABLE_MAN_PAGE_COMPRESSION)
        # uncompressed man pages; just install them
        UHD_INSTALL(FILES ${man_page_sources} DESTINATION ${PKG_MAN_DIR} COMPONENT manpages)
    endif(ENABLE_MAN_PAGE_COMPRESSION)
endif(ENABLE_MAN_PAGES)

=== host/lib/CMakeLists.txt ===
#
# Copyright 2010-2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Helpful Macros
########################################################################
macro(LIBUHD_APPEND_SOURCES)
    list(APPEND libuhd_sources ${ARGV})
endmacro(LIBUHD_APPEND_SOURCES)

macro(LIBUHD_APPEND_LIBS)
    list(APPEND libuhd_libs ${ARGV})
endmacro(LIBUHD_APPEND_LIBS)

macro(LIBUHD_PYTHON_GEN_SOURCE pyfile outfile)
    # Ensure that the directory exists for outfile
    get_filename_component(outfile_dir ${outfile} PATH)
    file(MAKE_DIRECTORY ${outfile_dir})

    # Make the outfile depend on the python script
    add_custom_command(
        OUTPUT ${outfile} DEPENDS ${pyfile} ${LIBUHD_PYTHON_GEN_SOURCE_DEPS}
        COMMAND ${PYTHON_EXECUTABLE} -B ${pyfile} ${outfile}
        COMMENT "Generating ${outfile}"
    )

    # Make libuhd depend on the outfile
    LIBUHD_APPEND_SOURCES(${outfile})
endmacro(LIBUHD_PYTHON_GEN_SOURCE)

macro(INCLUDE_SUBDIRECTORY subdir)
    # Insert the current directories on the front of the list
    list(INSERT _cmake_source_dirs 0 ${CMAKE_CURRENT_SOURCE_DIR})
    list(INSERT _cmake_binary_dirs 0 ${CMAKE_CURRENT_BINARY_DIR})

    # Set the current directories to the names of the subdirs
    set(CMAKE_CURRENT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/${subdir})
    set(CMAKE_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/${subdir})

    # Include the subdirectory CMakeLists to run it
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    include(${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt)

    # Reset the value of the current directories
    list(GET _cmake_source_dirs 0 CMAKE_CURRENT_SOURCE_DIR)
    list(GET _cmake_binary_dirs 0 CMAKE_CURRENT_BINARY_DIR)

    # Pop the subdir names of the front of the list
    list(REMOVE_AT _cmake_source_dirs 0)
    list(REMOVE_AT _cmake_binary_dirs 0)
endmacro(INCLUDE_SUBDIRECTORY)

########################################################################
# Register lower level components
########################################################################
message(STATUS "")
# Dependencies
find_package(LIBUSB)
find_package(DPDK)
LIBUHD_REGISTER_COMPONENT("USB" ENABLE_USB ON "ENABLE_LIBUHD;LIBUSB_FOUND" OFF OFF)
# Devices
LIBUHD_REGISTER_COMPONENT("B100" ENABLE_B100 ON "ENABLE_LIBUHD;ENABLE_USB" OFF OFF)
LIBUHD_REGISTER_COMPONENT("B200" ENABLE_B200 ON "ENABLE_LIBUHD;ENABLE_USB" OFF OFF)
LIBUHD_REGISTER_COMPONENT("USRP1" ENABLE_USRP1 ON "ENABLE_LIBUHD;ENABLE_USB" OFF OFF)
LIBUHD_REGISTER_COMPONENT("USRP2" ENABLE_USRP2 ON "ENABLE_LIBUHD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("X300" ENABLE_X300 ON "ENABLE_LIBUHD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("MPMD" ENABLE_MPMD ON "ENABLE_LIBUHD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("SIM" ENABLE_SIM ON "ENABLE_LIBUHD;ENABLE_MPMD;ENABLE_PYTHON_API" OFF OFF)
LIBUHD_REGISTER_COMPONENT("N300" ENABLE_N300 ON "ENABLE_LIBUHD;ENABLE_MPMD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("N320" ENABLE_N320 ON "ENABLE_LIBUHD;ENABLE_MPMD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("E320" ENABLE_E320 ON "ENABLE_LIBUHD;ENABLE_MPMD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("E300" ENABLE_E300 ON "ENABLE_LIBUHD;ENABLE_MPMD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("X400" ENABLE_X400 ON "ENABLE_LIBUHD;ENABLE_MPMD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("OctoClock" ENABLE_OCTOCLOCK ON "ENABLE_LIBUHD" OFF OFF)
LIBUHD_REGISTER_COMPONENT("DPDK" ENABLE_DPDK ON "ENABLE_MPMD;DPDK_FOUND" OFF OFF)

########################################################################
# Include subdirectories (different than add)
########################################################################
INCLUDE_SUBDIRECTORY(include)
INCLUDE_SUBDIRECTORY(cal)
INCLUDE_SUBDIRECTORY(features)
INCLUDE_SUBDIRECTORY(ic_reg_maps)
INCLUDE_SUBDIRECTORY(types)
INCLUDE_SUBDIRECTORY(convert)
INCLUDE_SUBDIRECTORY(rfnoc)
INCLUDE_SUBDIRECTORY(usrp)
INCLUDE_SUBDIRECTORY(usrp_clock)
INCLUDE_SUBDIRECTORY(utils)
INCLUDE_SUBDIRECTORY(experts)
INCLUDE_SUBDIRECTORY(extension)
INCLUDE_SUBDIRECTORY(transport)

########################################################################
# Build info
########################################################################
include(UHDBuildInfo)
UHD_LOAD_BUILD_INFO()
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/build_info.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/build_info.cpp
@ONLY)

########################################################################
# Setup UHD_VERSION_STRING for version.cpp
########################################################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/version.cpp
@ONLY)

########################################################################
# Append to the list of sources for lib uhd
########################################################################
LIBUHD_APPEND_SOURCES(
    ${CMAKE_CURRENT_BINARY_DIR}/build_info.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/device.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/image_loader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stream.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/exception.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/property_tree.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/version.cpp
)

if(ENABLE_C_API)
    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/error_c.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/version_c.cpp
    )
endif(ENABLE_C_API)

########################################################################
# Add common resource compiler subdirectory
########################################################################
add_subdirectory(rc)
LIBUHD_APPEND_LIBS(uhd_rc)

########################################################################
# Add DLL resource file to Windows build
########################################################################
if(MSVC)
    set(RC_VERSION_PATCH ${UHD_VERSION_PATCH})
    if(UHD_VERSION_DEVEL)
        set(RC_VERSION_PATCH "999")
    endif(UHD_VERSION_DEVEL)

    # Allow a custom .rc template file to be used
    if(CUSTOM_RC_FILE)
        if(IS_ABSOLUTE "${CUSTOM_RC_FILE}")
            set(UHD_RC_IN "${CUSTOM_RC_FILE}")
        else()
            set(UHD_RC_IN "${UHD_BINARY_DIR}/${CUSTOM_RC_FILE}")
        endif(IS_ABSOLUTE "${CUSTOM_RC_FILE}")
        message(STATUS "")
        message(STATUS "Using custom RC template: ${UHD_RC_IN}")
        message(STATUS "")
    else()
        set(UHD_RC_IN "${CMAKE_CURRENT_SOURCE_DIR}/uhd.rc.in")
    endif(CUSTOM_RC_FILE)
    set(UHD_RC_IN ${UHD_RC_IN} CACHE STRING "uhd.rc template filepath")

    configure_file(
        ${UHD_RC_IN}
        ${CMAKE_CURRENT_BINARY_DIR}/uhd.rc
    @ONLY)

    list(APPEND libuhd_sources ${CMAKE_CURRENT_BINARY_DIR}/uhd.rc)
endif(MSVC)

########################################################################
# Setup libuhd library
########################################################################
if(ENABLE_MPMD)
    include_directories(deps/rpclib/include)
    add_subdirectory(deps)
    list(APPEND libuhd_sources $<TARGET_OBJECTS:uhd_rpclib>)
endif()
add_library(uhd SHARED ${libuhd_sources})
target_link_libraries(uhd ${Boost_LIBRARIES} ${libuhd_libs})
if(ENABLE_DPDK)
    add_definitions(-DHAVE_DPDK)
    # The compile flags DPDK_CFLAGS add the DPDK_INCLUDE_DIRS include
    # directories and set the -march=native compiler flag.
    target_compile_options(uhd PRIVATE ${DPDK_CFLAGS})
    # The linker flags DPDK_LDFLAGS contains the list of DPDK libraries
    # as well as the path where to find the libraries
    target_link_options(uhd PUBLIC ${DPDK_LDFLAGS})
    # explicitly link against the DPDK libraries, otherwise there are
    # undefined references when linking libuhd
    target_link_libraries(uhd ${DPDK_LIBRARIES})
endif()
if(APPLE)
    target_link_options(uhd PRIVATE "LINKER:-undefined,dynamic_lookup")
    target_link_options(uhd PRIVATE "-flat_namespace")
endif(APPLE)
set_target_properties(uhd PROPERTIES DEFINE_SYMBOL "UHD_DLL_EXPORTS")
if(NOT LIBUHDDEV_PKG)
    set_target_properties(uhd PROPERTIES SOVERSION "${UHD_ABI_VERSION}")
    set_target_properties(uhd PROPERTIES VERSION "${UHD_ABI_VERSION}")
endif(NOT LIBUHDDEV_PKG)
if(DEFINED LIBUHD_OUTPUT_NAME)
    set_target_properties(uhd PROPERTIES OUTPUT_NAME ${LIBUHD_OUTPUT_NAME})
endif(DEFINED LIBUHD_OUTPUT_NAME)

if(ENABLE_SIM)
    # Get python include dirs
    # This contitional code somewhat duplicates logic also found in 
    # ../python/CMakeLists.txt but omits user messages. This avoid 
    # duplicate output, since SIM mode requires python support. 
    include_directories(${PYTHON_INCLUDE_DIRS})
    if(NOT pybind11_FOUND)
        set(PYBIND11_INCLUDE_DIR
            "${UHD_SOURCE_DIR}/lib/deps/pybind11/include"
            CACHE
            STRING
            "Location of PyBind11 includes"
        )
    endif()
    include_directories(${PYBIND11_INCLUDE_DIR})

    # For PYUHD we don't link against the python libraries, but when calling
    # python instead of being called by it, we have to.
    target_link_libraries(uhd ${PYTHON_LIBRARIES})

endif(ENABLE_SIM)

if(NOT UHDHOST_PKG) # Syntax makes it unusable by UHD_INSTALL
    install(TARGETS uhd
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries # .so file
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT libraries # .lib file
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT libraries # .dll file
    )
endif(NOT UHDHOST_PKG)

#######################################################
# Setup libuhd library (static)
#######################################################
if(ENABLE_STATIC_LIBS)
    add_library(uhd_static STATIC ${libuhd_sources} $<TARGET_OBJECTS:uhd_rc>)
    set_target_properties(uhd_static PROPERTIES OUTPUT_NAME uhd)
    set_target_properties(uhd_static PROPERTIES COMPILE_DEFINITIONS UHD_STATIC_LIB)
    target_link_libraries(uhd_static uhd_rc)
    install(TARGETS uhd_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} # .lib or .a file
    )
endif(ENABLE_STATIC_LIBS)

if(ENABLE_EXTEND_WIN_PACKAGING)
    if(ENABLE_USB AND NOT ENABLE_STATIC_LIBS)
        include(UHDLIBUSB)

        if(DEFINED UHD_LIBUSBDLLPATH)
            # UHD_INSTALL(FILES
            #     ${UHD_LIBUSBDLLPATH}
            #     DESTINATION ${CMAKE_INSTALL_BINDIR}
            #     COMPONENT winlibusb)
        install(FILES
                ${UHD_LIBUSBDLLPATH}
                DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT libraries)
        else()
            message(WARNING "Unable to locate libusb dynamic link library from LIBUSB_LIBRARIES: ${LIBUSB_LIBRARIES}")
        endif(DEFINED UHD_LIBUSBDLLPATH)

        # Variable LIBUSB_LICENSE_FILE is defined in top level CMakeLists.txt,
        # and the files gets generated in the UHDLIBUSB module.
        if(EXISTS ${UHD_LIBUSB_LICENSEFILE})
            UHD_INSTALL(FILES
                ${UHD_LIBUSB_LICENSEFILE}
                DESTINATION ${PKG_DOC_DIR}
                COMPONENT readme
            )
        else()
            message(WARNING "Did not find generated libusb license files at ${UHD_LIBUSB_LICENSEFILE}")
        endif(EXISTS ${UHD_LIBUSB_LICENSEFILE})
    endif(ENABLE_USB AND NOT ENABLE_STATIC_LIBS)
endif(ENABLE_EXTEND_WIN_PACKAGING)

=== host/python/CMakeLists.txt ===
#
# Copyright 2017-2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# This file included, use CMake directory variables
########################################################################

# Global Python API constants
set(SETUP_PY_IN       "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
set(SETUP_PY          "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
set(PYPROJECT_TOML_IN "${CMAKE_CURRENT_SOURCE_DIR}/pyproject.toml.in")
set(PYPROJECT_TOML    "${CMAKE_CURRENT_BINARY_DIR}/pyproject.toml")
set(TIMESTAMP_FILE    "${CMAKE_CURRENT_BINARY_DIR}/build/timestamp")
# By default we assume Pre-Alpha status (development)
set(UHD_DEV_STATUS    "Development Status :: 2 - Pre-Alpha")
# Only in release mode we set the status to Beta or Release
if (UHD_RELEASE_MODE)
    if (UHD_GIT_TAG MATCHES "^v[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+$")
        message(STATUS "Set development status to release")
        set(UHD_DEV_STATUS "Development Status :: 5 - Production/Stable")
    else()
        if (UHD_GIT_TAG MATCHES "^v[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+-rc[0-9]+$")
            message(STATUS "Set development status to release candidate")
            set(UHD_DEV_STATUS "Development Status :: 4 - Beta")
        else()
            message(WARNING "Configured to build in release mode, but branch name does not match release (candidate) pattern.")
        endif()
    endif()
endif()
# convert binary directory to native format to use in SETUP_PY file.
file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} NATIVE_CURRENT_BINARY_DIR)
configure_file(${SETUP_PY_IN} ${SETUP_PY})
if(WIN32)
    configure_file(${PYPROJECT_TOML_IN} ${PYPROJECT_TOML})
endif(WIN32)
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/uhd_build.py" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file(COPY "${CMAKE_SOURCE_DIR}/README.md" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
file(COPY "${CMAKE_SOURCE_DIR}/LICENSE" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")

# This sets the UHD_INSTALL_PATH variable in the __init__.py file so that the UHD python module can find the UHD library.
set(UHD_INSTALL_PATH ${CMAKE_INSTALL_PREFIX})
set(UHD_INIT_IN "${CMAKE_CURRENT_SOURCE_DIR}/uhd/__init__.py.in")
set(UHD_INIT "${CMAKE_CURRENT_BINARY_DIR}/uhd/__init__.py")
configure_file(${UHD_INIT_IN} ${UHD_INIT} @ONLY)

# If we're not in a virtual environment, then we need to figure out where to
# install the Python module. Do this here so we can use the value for UHD_PYTHON_DIR
# in the simulator.
if(NOT DEFINED UHD_PYTHON_DIR)
    execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
        # Avoid the posix_local install scheme
        "import os,sysconfig;\
        install_scheme = 'posix_prefix';\
        platlib = sysconfig.get_path('platlib', scheme=install_scheme);\
        prefix = sysconfig.get_config_var('prefix');\
        print(os.path.relpath(platlib, prefix));"
        OUTPUT_VARIABLE UHD_PYTHON_DIR OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif(NOT DEFINED UHD_PYTHON_DIR)

# If ENABLE_PYTHON_API is OFF, then we can skip most of the work and will just
# install a bunch of Python files.
if(NOT ENABLE_PYTHON_API AND ENABLE_PYMOD_UTILS)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd/__init__.py.in-pymod
        ${CMAKE_CURRENT_BINARY_DIR}/uhd/__init__.py
        @ONLY)
    # List of Python files that are part of the module but don't get
    # generated during build time and don't require libpyuhd.
    # Note: When adding Python files into uhd/, they don't get added to the
    # dependency list until CMake is re-run.
    file(GLOB_RECURSE PYUHD_FILES
        ${CMAKE_CURRENT_BINARY_DIR}/uhd/__init__.py
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd/dsp/*.py
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd/rfnoc_utils/*.py
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd/rfnoc_utils/*.mako
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd/rfnoc_utils/*.yml
        ${CMAKE_CURRENT_BINARY_DIR}/uhd/__init__.py
    )

    # This copies the contents of host/python/uhd into the build directory. We will
    # use that as a staging ground for installing the final module to the system.
    # We make sure that we always have an up-to-date copy in here.
    add_custom_command(OUTPUT ${TIMESTAMP_FILE}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/uhd/
        COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/uhd/rfnoc_utils ${CMAKE_CURRENT_BINARY_DIR}/uhd/rfnoc_utils
        COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/uhd/dsp ${CMAKE_CURRENT_BINARY_DIR}/uhd/dsp
        COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} -q build
        COMMAND ${CMAKE_COMMAND} -E touch ${TIMESTAMP_FILE}
        DEPENDS ${PYUHD_FILES})
    add_custom_target(pyuhd_library ALL DEPENDS ${TIMESTAMP_FILE})
    UHD_PYTHON_INSTALL_MODULE(
        MODULE "uhd"
    )
    return()
endif()


if(pybind11_FOUND)
  message(STATUS "Using Pybind11 from: ${pybind11_INCLUDE_DIR}")
else()
  set(pybind11_INCLUDE_DIR
      "${UHD_SOURCE_DIR}/lib/deps/pybind11/include"
      CACHE STRING
      "Location of PyBind11 includes"
  )
  message(STATUS "Using in-tree Pybind11.")
endif()

# Get include dirs
execute_process(
    COMMAND "${PYTHON_EXECUTABLE}" -c
    "try:\n import numpy\n import os\n inc_path = numpy.get_include()\n if os.path.exists(os.path.join(inc_path, 'numpy', 'arrayobject.h')):\n  print(inc_path, end='')\nexcept:\n pass"
    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR)

# Build pyuhd library
add_library(pyuhd SHARED
    pyuhd.cpp
    ${UHD_SOURCE_DIR}/lib/property_tree_python.cpp
    ${UHD_SOURCE_DIR}/lib/device_python.cpp
    ${UHD_SOURCE_DIR}/lib/usrp/multi_usrp_python.cpp
    ${UHD_SOURCE_DIR}/lib/usrp_clock/multi_usrp_clock_python.cpp
)

# python expects extension modules with a particular suffix
if(WIN32)
    set_target_properties(pyuhd PROPERTIES PREFIX "lib" SUFFIX ".pyd")
else()
    execute_process(
        COMMAND "${PYTHON_EXECUTABLE}" -c
        "from sysconfig import get_config_var; print(get_config_var('EXT_SUFFIX'))"
        OUTPUT_VARIABLE PYTHON_EXTENSION_SUFFIX
    )
    string(STRIP ${PYTHON_EXTENSION_SUFFIX} PYTHON_EXTENSION_SUFFIX)
    if(${PYTHON_EXTENSION_SUFFIX} STREQUAL "None")
        set(PYTHON_EXTENSION_SUFFIX ${CMAKE_SHARED_MODULE_SUFFIX})
    endif()
    set_target_properties(pyuhd
        PROPERTIES
        PREFIX "lib"
        SUFFIX ${PYTHON_EXTENSION_SUFFIX}
    )
endif(WIN32)
target_include_directories(pyuhd PUBLIC
    ${PYTHON_INCLUDE_DIRS}
    ${PYTHON_NUMPY_INCLUDE_DIR}
    ${UHD_SOURCE_DIR}/lib
    ${pybind11_INCLUDE_DIR}
    # Directory will exist as the Python API build depends on LibUHD being enabled
    ${UHD_BINARY_DIR}/lib/ic_reg_maps
)

if(WIN32)
    target_link_libraries(pyuhd ${Boost_LIBRARIES} ${PYTHON_LIBRARIES} uhd)
else()
    # for extension module, proper to NOT link against python library and instead
    # add dynamic lookup link option on OSX
    target_link_libraries(pyuhd ${Boost_LIBRARIES} uhd)
    if(APPLE)
        target_link_options(pyuhd PRIVATE "LINKER:-undefined,dynamic_lookup")
    endif(APPLE)
endif(WIN32)
# Copy pyuhd library to the staging directory
add_custom_command(TARGET pyuhd
    POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:pyuhd> ${CMAKE_CURRENT_BINARY_DIR}/uhd/$<TARGET_FILE_NAME:pyuhd>)

# List of Python files that are part of the module but don't get
# generated during build time.
# Note: When adding Python files into uhd/, they don't get added to the
# dependency list until CMake is re-run.
file(GLOB_RECURSE PYUHD_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/uhd/*.py
    ${CMAKE_CURRENT_SOURCE_DIR}/uhd/*.mako
    ${CMAKE_CURRENT_SOURCE_DIR}/uhd/*.yml
)

if(ENABLE_SIM)
    set(MPM_DEVICE "sim")
    # Whereever UHD Python gets installed, also install that from MPM.
    set(USRP_MPM_PYTHON_DIR ${UHD_PYTHON_DIR})
    add_subdirectory(${UHD_SOURCE_DIR}/../mpm/python simulator)
    # simulator/usrp_mpm needs to be copied to usrp_mpm because setuptools only detects import packages in the working directory
    add_custom_target(copy_mpm_packages ALL DEPENDS usrp_mpm)
    add_custom_command(TARGET copy_mpm_packages
                       PRE_BUILD
                       COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm
                       COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/dboard_manager
                       COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/periph_manager
                       COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/simulator
                       COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/sys_utils
                       COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/xports

                       COMMAND ${CMAKE_COMMAND} -E copy
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/dboard_manager/base.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/dboard_manager/__init__.py
                       ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/dboard_manager

                       COMMAND ${CMAKE_COMMAND} -E copy
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/periph_manager/base.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/periph_manager/common.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/periph_manager/sim.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/periph_manager/__init__.py
                       ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/periph_manager

                       COMMAND ${CMAKE_COMMAND} -E copy_directory
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/simulator
                       ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/simulator

                       COMMAND ${CMAKE_COMMAND} -E copy_directory
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/sys_utils
                       ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/sys_utils

                       COMMAND ${CMAKE_COMMAND} -E copy
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/xports/xportmgr_udp.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/xports/__init__.py
                       ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/xports

                       COMMAND ${CMAKE_COMMAND} -E copy
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/compat_num.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/discovery.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/eeprom.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/ethdispatch.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/gpsd_iface.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/mpmlog.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/mpmtypes.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/mpmutils.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/prefs.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/tlv_eeprom.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/rpc_server.py
                       ${CMAKE_CURRENT_BINARY_DIR}/simulator/usrp_mpm/__init__.py
                       ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm)
    # Move usrp_hwd.py into usrp_mpm so that it is included in the package
    configure_file(${UHD_SOURCE_DIR}/../mpm/python/usrp_hwd.py
                   ${CMAKE_CURRENT_BINARY_DIR}/usrp_mpm/usrp_hwd.py COPYONLY)
    set(PYUHD_FILES ${PYUHD_FILES} copy_mpm_packages)
endif(ENABLE_SIM)

# This copies the *.py and *.mako files of host/python/uhd into the build directory.

=== host/python/requirements.txt ===
# Python packages required to build UHD with Python support

# Process yaml files, e.g. for RFNoC image builder
ruamel.yaml

# Numpy is used to generate or process IQ data
numpy<2.0.0

# Mako is needed for generate source stubs (e.g. register maps)
mako

# Needed for the image downloader
requests

# Needed to build the Python bindings for UHD
setuptools

=== host/tests/CMakeLists.txt ===

# Copyright 2010-2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# unit test support
########################################################################
include(UHDUnitTest)

########################################################################
# build test common
########################################################################
set(test_common_SOURCEDIR ${CMAKE_CURRENT_SOURCE_DIR}/common)
add_subdirectory(common)
link_directories(${test_common_SOURCEDIR})

########################################################################
# unit test suite
########################################################################
set(test_sources
    actions_test.cpp
    addr_test.cpp
    buffer_test.cpp
    byteswap_test.cpp
    cast_test.cpp
    cal_database_test.cpp
    cal_data_iq_test.cpp
    cal_data_gain_pwr_test.cpp
    chdr_parse_test.cpp
    cal_data_dsa_test.cpp
    compat_test.cpp
    constrained_device_args_test.cpp
    convert_test.cpp
    dict_test.cpp
    eeprom_utils_test.cpp
    error_test.cpp
    fp_compare_delta_test.cpp
    fp_compare_epsilon_test.cpp
    gain_group_test.cpp
    interpolation_test.cpp
    isatty_test.cpp
    log_test.cpp
    math_test.cpp
    narrow_cast_test.cpp
    property_test.cpp
    ranges_test.cpp
    rfnoc_node_test.cpp
    rfnoc_propprop_test.cpp
    scope_exit_test.cpp
    sensors_test.cpp
    soft_reg_test.cpp
    sph_recv_test.cpp
    sph_send_test.cpp
    subdev_spec_test.cpp
    time_spec_test.cpp
    tasks_test.cpp
    vrt_test.cpp
    expert_test.cpp
    fe_conn_test.cpp
    link_test.cpp
    rx_streamer_test.cpp
    tx_streamer_test.cpp
    block_id_test.cpp
    rfnoc_property_test.cpp
    multichan_register_iface_test.cpp
)

# Note: Python-based tests cannot have the same name as a C++-based test (i.e.,
# only differ in the cpp/py file extension). If in doubt, prepend 'py'
set(pytest_sources
    pyranges_test.py
    verify_fbs_test.py
    pychdr_parse_test.py
    uhd_image_downloader_test.py
    device_addr_test.py
)

#turn each test cpp file into an executable with an int main() function
add_definitions(-DBOOST_TEST_DYN_LINK -DBOOST_TEST_MAIN)

if(ENABLE_C_API)
    list(APPEND test_sources
        eeprom_c_test.c
        error_c_test.cpp
        ranges_c_test.c
        sensors_c_test.c
        string_vector_c_test.c
        subdev_spec_c_test.c
    )
endif(ENABLE_C_API)

include_directories("${UHD_SOURCE_DIR}/lib/include")
include_directories("${UHD_BINARY_DIR}/lib/include")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/common")

#for each source: build an executable, register it as a test
foreach(test_source ${test_sources})
    get_filename_component(test_name ${test_source} NAME_WE)
    add_executable(${test_name} ${test_source})
    target_link_libraries(${test_name} uhd uhd_test ${Boost_LIBRARIES})
    UHD_ADD_TEST(${test_name} ${test_name})
    UHD_INSTALL(TARGETS ${test_name} RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)
endforeach(test_source)

#for benchmarks, build executable but do not register
foreach(benchmark_source ${benchmark_sources})
    get_filename_component(benchmark_name ${benchmark_source} NAME_WE)
    add_executable(${benchmark_name} ${benchmark_source})
    target_link_libraries(${benchmark_name} uhd uhd_test ${Boost_LIBRARIES})
    UHD_INSTALL(TARGETS ${benchmark_name} RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)
endforeach(benchmark_source)

if(ENABLE_PYTHON_API)
    foreach(test_source ${pytest_sources})
        get_filename_component(test_name ${test_source} NAME_WE)
        UHD_ADD_PYTEST(${test_name})
    endforeach(test_source)
    UHD_INSTALL(FILES ${pytest_sources}
        DESTINATION ${PKG_LIB_DIR}/tests
        COMPONENT tests
    )
endif(ENABLE_PYTHON_API)

###############################################################################
# Add a unit test that requires linkage to internal parts of UHD which are not
# API
###############################################################################
macro(UHD_ADD_NONAPI_TEST)
    cmake_parse_arguments(test "NOAUTORUN" "TARGET" "INCLUDE_DIRS;EXTRA_SOURCES;EXTRA_LIBS;DEFINITIONS" ${ARGN})
    get_filename_component(test_name ${test_TARGET} NAME_WE)
    include_directories(${test_INCLUDE_DIRS})
    add_executable(${test_name} ${test_TARGET} ${test_EXTRA_SOURCES})
    target_link_libraries(${test_name} uhd uhd_test ${Boost_LIBRARIES})
    target_compile_definitions(${test_name} PUBLIC ${test_DEFINITIONS})
    if(NOT ${test_NOAUTORUN})
        UHD_ADD_TEST(${test_name} ${test_name})
    endif(NOT ${test_NOAUTORUN})
    UHD_INSTALL(TARGETS ${test_name}
        RUNTIME
        DESTINATION ${PKG_LIB_DIR}/tests
        COMPONENT tests)
endmacro(UHD_ADD_NONAPI_TEST)

###############################################################################
# Add a unit test for an RFNoC block controller
###############################################################################
macro(UHD_ADD_RFNOC_BLOCK_TEST)
    cmake_parse_arguments(test "NOAUTORUN" "TARGET" "INCLUDE_DIRS;EXTRA_SOURCES;EXTRA_LIBS" ${ARGN})
    UHD_ADD_NONAPI_TEST(
        TARGET rfnoc_block_tests/${test_TARGET}
        INCLUDE_DIRS
        ${test_INCLUDE_DIRS}
    )
endmacro(UHD_ADD_RFNOC_BLOCK_TEST)

###############################################################################
# Add a unit test for an RFNoC block controller that requires non-api sources
###############################################################################
macro(UHD_ADD_RFNOC_BLOCK_NONAPI_TEST)
    cmake_parse_arguments(test "NOAUTORUN" "TARGET" "INCLUDE_DIRS;EXTRA_SOURCES;EXTRA_LIBS" ${ARGN})
    UHD_ADD_NONAPI_TEST(
        TARGET rfnoc_block_tests/${test_TARGET}
        EXTRA_SOURCES
        ${test_EXTRA_SOURCES}
        INCLUDE_DIRS
        ${test_INCLUDE_DIRS}
    )
endmacro(UHD_ADD_RFNOC_BLOCK_NONAPI_TEST)

###############################################################################
# Add unit tests for RFNoC blocks that don't require special linkage
###############################################################################
set(rfnoc_block_sources
    addsub_block_test.cpp
    ddc_block_test.cpp
    duc_block_test.cpp
    fft_block_test.cpp
    fft_block_test_v2.cpp
    fir_filter_block_test.cpp
    fosphor_block_test.cpp
    keep_one_in_n_test.cpp
    logpwr_block_test.cpp
    moving_average_block_test.cpp
    null_block_test.cpp
    replay_block_test.cpp
    siggen_block_test.cpp
    split_stream_block_test.cpp
    switchboard_block_test.cpp
    vector_iir_block_test.cpp
    window_block_test.cpp
    lc_block_test.cpp
)

foreach(test_source ${rfnoc_block_sources})
    get_filename_component(test_name ${test_source} NAME_WE)
    add_executable(${test_name} rfnoc_block_tests/${test_source})
    target_link_libraries(${test_name} uhd uhd_test ${Boost_LIBRARIES})
    UHD_ADD_TEST(${test_name} ${test_name})
    UHD_INSTALL(TARGETS ${test_name} RUNTIME DESTINATION ${PKG_LIB_DIR}/tests/rfnoc_block_tests COMPONENT tests)
endforeach(test_source)


###############################################################################
# Now add all unit tests that require special linkage
###############################################################################
if(ENABLE_DPDK)
    find_package(DPDK)
    UHD_ADD_NONAPI_TEST(
        TARGET "dpdk_test.cpp"
        EXTRA_SOURCES
        ${UHD_SOURCE_DIR}/lib/utils/config_parser.cpp
        ${UHD_SOURCE_DIR}/lib/utils/paths.cpp
        ${UHD_SOURCE_DIR}/lib/utils/pathslib.cpp
        ${UHD_SOURCE_DIR}/lib/utils/prefs.cpp
        ${UHD_SOURCE_DIR}/lib/transport/adapter.cpp
        ${UHD_SOURCE_DIR}/lib/transport/uhd-dpdk/dpdk_common.cpp
        ${UHD_SOURCE_DIR}/lib/transport/uhd-dpdk/dpdk_io_service.cpp
        ${UHD_SOURCE_DIR}/lib/transport/udp_dpdk_link.cpp
        INCLUDE_DIRS
        ${DPDK_INCLUDE_DIRS}
        EXTRA_LIBS ${DPDK_LIBRARIES}
        NOAUTORUN # Don't register for auto-run, it requires special config
    )
    UHD_ADD_NONAPI_TEST(
        TARGET "dpdk_port_test.cpp"
        EXTRA_SOURCES
        ${UHD_SOURCE_DIR}/lib/utils/config_parser.cpp
        ${UHD_SOURCE_DIR}/lib/utils/paths.cpp
        ${UHD_SOURCE_DIR}/lib/utils/pathslib.cpp
        ${UHD_SOURCE_DIR}/lib/utils/prefs.cpp
        ${UHD_SOURCE_DIR}/lib/transport/adapter.cpp
        ${UHD_SOURCE_DIR}/lib/transport/uhd-dpdk/dpdk_common.cpp
        ${UHD_SOURCE_DIR}/lib/transport/uhd-dpdk/dpdk_io_service.cpp
        ${UHD_SOURCE_DIR}/lib/transport/udp_dpdk_link.cpp
        INCLUDE_DIRS
        ${DPDK_INCLUDE_DIRS}
        EXTRA_LIBS ${DPDK_LIBRARIES}
        NOAUTORUN # Don't register for auto-run, it requires special config
    )
    target_compile_options(dpdk_test PRIVATE ${DPDK_CFLAGS})
    target_compile_options(dpdk_port_test PRIVATE ${DPDK_CFLAGS})
ENDIF(ENABLE_DPDK)

UHD_ADD_NONAPI_TEST(
    TARGET "system_time_test.cpp"
    EXTRA_SOURCES
    "${UHD_SOURCE_DIR}/lib/utils/system_time.cpp"
)

UHD_ADD_NONAPI_TEST(
    TARGET "streamer_benchmark.cpp"
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/rfnoc/chdr_packet_writer.cpp
    ${UHD_SOURCE_DIR}/lib/rfnoc/chdr_ctrl_xport.cpp
    ${UHD_SOURCE_DIR}/lib/rfnoc/chdr_rx_data_xport.cpp
    ${UHD_SOURCE_DIR}/lib/rfnoc/chdr_tx_data_xport.cpp
    ${UHD_SOURCE_DIR}/lib/transport/inline_io_service.cpp
    NOAUTORUN # Don't register for auto-run
)

UHD_ADD_NONAPI_TEST(
    TARGET "config_parser_test.cpp"
    EXTRA_SOURCES ${UHD_SOURCE_DIR}/lib/utils/config_parser.cpp
)

# Careful: This is to satisfy the out-of-library build of paths.cpp. This is
# duplicate code from lib/utils/CMakeLists.txt, and it's been simplified.
# TODO Figure out if this is even needed
set(UHD_LIB_DIR "lib")
file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}" UHD_PKG_PATH)
string(REPLACE "\\" "\\\\" UHD_PKG_PATH "${UHD_PKG_PATH}")
set_source_files_properties(
    ${UHD_SOURCE_DIR}/lib/utils/paths.cpp
    PROPERTIES COMPILE_DEFINITIONS
    "UHD_PKG_PATH=\"${UHD_PKG_PATH}\";UHD_LIB_DIR=\"${UHD_LIB_DIR}\""
)
UHD_ADD_NONAPI_TEST(
    TARGET "paths_test.cpp"
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/utils/pathslib.cpp
)

UHD_ADD_NONAPI_TEST(
    TARGET rfnoc_detailgraph_test.cpp
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/rfnoc/graph.cpp
    DEFINITIONS "-DUHD_RFNOC_DETAILGRAPH_TEST"
)

UHD_ADD_NONAPI_TEST(
    TARGET rfnoc_topograph_test.cpp
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/rfnoc/topo_graph.cpp
)

UHD_ADD_NONAPI_TEST(
    TARGET rfnoc_chdr_test.cpp
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/rfnoc/chdr_packet_writer.cpp
    INCLUDE_DIRS
    ${UHD_BINARY_DIR}/lib/rfnoc/
    ${UHD_SOURCE_DIR}/lib/rfnoc/
)

UHD_ADD_NONAPI_TEST(
    TARGET client_zero_test.cpp
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/rfnoc/client_zero.cpp
)

UHD_ADD_NONAPI_TEST(
    TARGET zbx_cpld_test.cpp
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/usrp/dboard/zbx/zbx_cpld_ctrl.cpp
    ${UHD_SOURCE_DIR}/lib/usrp/dboard/zbx/zbx_lo_ctrl.cpp
    ${UHD_SOURCE_DIR}/lib/usrp/common/lmx2572.cpp
    INCLUDE_DIRS
    ${UHD_BINARY_DIR}/lib/ic_reg_maps
)

UHD_ADD_NONAPI_TEST(
    TARGET lmx2572_test.cpp
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/usrp/common/lmx2572.cpp
    INCLUDE_DIRS
    ${UHD_BINARY_DIR}/lib/ic_reg_maps
)

UHD_ADD_NONAPI_TEST(
    TARGET adf535x_test.cpp
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/usrp/common/adf535x.cpp
    INCLUDE_DIRS
    ${UHD_BINARY_DIR}/lib/ic_reg_maps
)

UHD_ADD_NONAPI_TEST(
    TARGET "max287x_test.cpp"
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/include/uhdlib/usrp/common/max287x.hpp
    INCLUDE_DIRS
    ${UHD_BINARY_DIR}/lib/ic_reg_maps
)

UHD_ADD_NONAPI_TEST(
    TARGET "tmp468_test.cpp"
    EXTRA_SOURCES
    ${UHD_SOURCE_DIR}/lib/usrp/common/tmp468.cpp
)

set_source_files_properties(
    ${UHD_SOURCE_DIR}/lib/utils/system_time.cpp
    PROPERTIES COMPILE_DEFINITIONS
    "HAVE_MICROSEC_CLOCK"
)

IF(ENABLE_X400)
    if (NOT APPLE)

=== host/utils/CMakeLists.txt ===
#
# Copyright 2010-2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

set(CONFIG_PATH "${CMAKE_INSTALL_PREFIX}/${PKG_DATA_DIR}")

########################################################################
# First, only utilities which get installed with ENABLE_PYMOD_UTILS.
# These require Mako and ruamel.yaml.
########################################################################
if(ENABLE_PYMOD_UTILS)
    ### RFNoC Image Builder
    UHD_INSTALL(PROGRAMS
        ${CMAKE_CURRENT_SOURCE_DIR}/rfnoc_image_builder.py
        RENAME rfnoc_image_builder
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT utilities
    )

    ### RFNoC modtool. Note this also requires the RFNoC gain OOT.
    UHD_INSTALL(PROGRAMS
        ${CMAKE_CURRENT_SOURCE_DIR}/rfnoc_modtool.py
        RENAME rfnoc_modtool
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT utilities
    )

    file(GLOB_RECURSE RFNOC_GAIN_OOT_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/apps/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/cmake/*
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/examples/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/fpga/gain/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/include/rfnoc/gain/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/lib/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/python/*
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/README.md
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/rfnoc/CMakeLists.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain/rfnoc/blocks/CMakeLists.txt
        )

    add_custom_target(
        rfnoc_newmod ALL
        DEPENDS ${RFNOC_GAIN_OOT_FILES}
        COMMAND
        "${PYTHON_EXECUTABLE}" "${UHD_SOURCE_DIR}/cmake/Modules/copy_rfnoc_newmod.py"
        "--source" "${CMAKE_CURRENT_SOURCE_DIR}/../examples/rfnoc-gain"
        "--dest" "${CMAKE_CURRENT_BINARY_DIR}/rfnoc-newmod"
        "--module-dir" "${CMAKE_CURRENT_SOURCE_DIR}/../python/uhd"
        COMMENT "Generating rfnoc-newmod"
    )
    install(DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}/rfnoc-newmod
        DESTINATION ${PKG_DATA_DIR}
        COMPONENT utilities)
endif(ENABLE_PYMOD_UTILS)

########################################################################
# Now, utilities which do not depend on Mako or ruamel.yaml
########################################################################
# Decide if we install all utilities into the runtime path
if(LINUX OR BSD OR CMAKE_SYSTEM_NAME STREQUAL "GNU")
    set(UHD_INSTALL_ALL_UTILS TRUE)
else()
    set(UHD_INSTALL_ALL_UTILS FALSE)
endif()


# This section must only include Python utilities that do not depend on uhd
if(ENABLE_PYMOD_UTILS OR ENABLE_UTILS)
    ### UHD Images downloader
    # Configure the scripts
    file(READ ${CMAKE_CURRENT_SOURCE_DIR}/../../images/manifest.txt CMAKE_MANIFEST_CONTENTS)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_images_downloader.py.in
        ${CMAKE_CURRENT_BINARY_DIR}/uhd_images_downloader.py
    @ONLY)
    # TODO: FIXME when know how.
    # This is a hack to force cmake regenerate uhd_images_downloader.py
    # whenever manifest.txt file changed.
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/../../images/manifest.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../../images/manifest.txt
    COPYONLY)

    UHD_INSTALL(PROGRAMS
        ${CMAKE_CURRENT_BINARY_DIR}/uhd_images_downloader.py
        DESTINATION ${PKG_LIB_DIR}/utils
        COMPONENT utilities
    )
    # On Linux/Unix systems, also install into $PATH
    if(UHD_INSTALL_ALL_UTILS)
        UHD_INSTALL(PROGRAMS
            ${CMAKE_CURRENT_BINARY_DIR}/uhd_images_downloader.py
            RENAME uhd_images_downloader
            DESTINATION ${CMAKE_INSTALL_BINDIR}
            COMPONENT utilities
        )
    endif()
    if(NOT HAVE_PYTHON_MODULE_REQUESTS)
        message(WARNING
            "Python module `requests' not found -- uhd_images_downloader.py "
            "will not work without it.")
        message(WARNING
            "You may be able to install this by running 'pip install requests'")
    endif(NOT HAVE_PYTHON_MODULE_REQUESTS)

    ### USRP2 Card Burner
    if(ENABLE_USRP2)
        if(WIN32 AND UHD_RELEASE_MODE) #include dd.exe
            file(DOWNLOAD
                "http://files.ettus.com/dd.exe"
                ${CMAKE_CURRENT_BINARY_DIR}/dd.exe
            )
            UHD_INSTALL(FILES
                ${CMAKE_CURRENT_BINARY_DIR}/dd.exe
                DESTINATION ${PKG_LIB_DIR}/utils
                COMPONENT utilities
            )
        endif(WIN32 AND UHD_RELEASE_MODE)
        if(UHD_INSTALL_ALL_UTILS)
            UHD_INSTALL(PROGRAMS
                usrp2_recovery.py
                DESTINATION ${PKG_LIB_DIR}/utils
                COMPONENT utilities
            )
            UHD_INSTALL(PROGRAMS
                usrp2_card_burner.py
                RENAME usrp2_card_burner
                DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT utilities
            )
        endif()
        UHD_INSTALL(PROGRAMS
            usrp2_card_burner.py
            DESTINATION ${PKG_LIB_DIR}/utils
            COMPONENT utilities
        )
    endif(ENABLE_USRP2)

endif(ENABLE_PYMOD_UTILS OR ENABLE_UTILS)

if(NOT ENABLE_UTILS)
    return()
endif()

########################################################################
# Utilities that get installed into the runtime path
########################################################################
set(util_runtime_sources
    uhd_config_info.cpp
    uhd_find_devices.cpp
    uhd_usrp_probe.cpp
    uhd_image_loader.cpp
    uhd_cal_rx_iq_balance.cpp
    uhd_cal_tx_dc_offset.cpp
    uhd_cal_tx_iq_balance.cpp
    uhd_adc_self_cal.cpp
)

#for each source: build an executable and install
foreach(util_source ${util_runtime_sources})
    get_filename_component(util_name ${util_source} NAME_WE)
    add_executable(${util_name} ${util_source})
    target_link_libraries(${util_name} uhd ${Boost_LIBRARIES})
    UHD_INSTALL(TARGETS ${util_name} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT utilities)
endforeach(util_source)

if(ENABLE_PYTHON_API)
    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/usrpctl.py"
        "${CMAKE_CURRENT_BINARY_DIR}/usrpctl"
    )
    UHD_INSTALL(PROGRAMS
        ${CMAKE_CURRENT_BINARY_DIR}/usrpctl
        RENAME usrpctl
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT utilities
    )
endif()

########################################################################
# Utilities that get installed into the share path
########################################################################
set(util_share_sources
    converter_benchmark.cpp
    query_gpsdo_sensors.cpp
    usrp_burn_db_eeprom.cpp
    usrp_burn_mb_eeprom.cpp
)
set(util_share_sources_py
    converter_benchmark.py
)
if(ENABLE_USB)
    find_package(LIBUSB)
    list(APPEND util_share_sources
        fx2_init_eeprom.cpp
    )
    include_directories(${LIBUSB_INCLUDE_DIRS})
    if(ENABLE_B200)
        list(APPEND util_share_sources
            b2xx_fx3_utils.cpp
        )
        # Additional include directories for b2xx_fx3_utils
        include_directories(
            ${CMAKE_CURRENT_SOURCE_DIR}/../lib/include
            ${CMAKE_CURRENT_SOURCE_DIR}/../lib/usrp/b200
            ${CMAKE_CURRENT_SOURCE_DIR}/../lib/usrp/common
            ${CMAKE_CURRENT_SOURCE_DIR}/../lib/usrp/common/ad9361_driver
        )
    endif(ENABLE_B200)
endif(ENABLE_USB)
if(ENABLE_OCTOCLOCK)
    list(APPEND util_share_sources
        octoclock_burn_eeprom.cpp
    )
endif(ENABLE_OCTOCLOCK)

if(LINUX AND ENABLE_USB)
    UHD_INSTALL(FILES
        uhd-usrp.rules
        DESTINATION ${PKG_LIB_DIR}/utils
        COMPONENT utilities
    )
endif(LINUX AND ENABLE_USB)

#for each source: build an executable and install
foreach(util_source ${util_share_sources})
    get_filename_component(util_name ${util_source} NAME_WE)
    add_executable(${util_name} ${util_source})
    target_link_libraries(${util_name} uhd ${Boost_LIBRARIES})
    UHD_INSTALL(TARGETS ${util_name} RUNTIME DESTINATION ${PKG_LIB_DIR}/utils COMPONENT utilities)
endforeach(util_source)
foreach(util_source ${util_share_sources_py})
    UHD_INSTALL(PROGRAMS
        ${CMAKE_CURRENT_SOURCE_DIR}/${util_source}
        DESTINATION ${PKG_LIB_DIR}/utils
        COMPONENT utilities
    )
endforeach(util_source)

########################################################################
# Other files that are not utilities or executables
########################################################################
if(WIN32)
    set(windows_extra_files
        FastSendDatagramThreshold.reg
    )
    UHD_INSTALL(
        FILES ${windows_extra_files}
        DESTINATION ${PKG_DATA_DIR}
        COMPONENT utilities
    )
endif(WIN32)

add_subdirectory(latency)

=== debian/changelog ===
uhd (4.9.0.0+ds1-1) unstable; urgency=medium

  [ A. Maitland Bottoms ]
  * New upstream release

  [Ettus Research]
  * Highlights / Main Changes
    - Support for USRP B206mini-i
    - Support for OBX daughterboard
  * New Features
    - OBX daughterboard and B206mini support added.
    - X3x0: Add support for the gps_iface feature. This allows sending arbitrary
      commands to the GPS module.
    - rfnoc_modtool: Add a new subcommand, `make-yaml`, that generates a block
      YAML file from some user inputs. When calling `rfnoc_modtool add`  without
      a valid block YAML file, the tool will now automatically call `make-yaml` to
      generate a new YAML file.
    - Added support for processing multiple samples per cycle in FFT block.
    - Improved RFNoC OOT Block support:
      New repository containing official RFNoC OOT Blocks
      (https://github.com/EttusResearch/rfnoc-oot-blocks)
      - Added new RFNoC Aurora Block for TX and RX remote streaming applications
        to and from Aurora capable compute nodes like FPGA Coprocessors.
  * API Changes
    - `uhd::math::gcd` and `uhd::math::lcm` are removed from the public
       headers. Use `std::gcd` and `std::lcm` instead if C++17 is available,
       or `boost::math::gcd` and `boost::math::lcm` if not.
    - When calling `recv()` on an RX streamer connected to an RFNoC device, we
      no longer artificially inflate the timeout value. The old behaviour was
      in some cases abused to detect overruns, but this is not a reliable method
      and is now explicitly declared unsupported.
  * Bug Fixes
    - RFNoC
      - Calling `recv()` on an RX streamer connected to an RFNoC device with a
        zero timeout value now correctly returns immediately.
      - rfnoc-gain: Moved the fpga/ subdirectory under rfnoc/. This way, the
        directory structure inside the OOT module is identical to the directory
        structure after installation.
    - X410:
      - Fixed NCO reset mechanism that caused ADC self-cal errors to occur during
        reopening of a UHD session when timed tune commands were previously used.
  * Removals / Deprecations
    - Removed tools/uhd_dump. This tool is obsolete, the USRP X3x0 is not even
      compatible with it any more. Dumps can be recorded and analyzed with wireshark
      and the UHD dissectors in here.
    - Removed network_relay example.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 08 Sep 2025 13:25:09 -0400

=== debian/control ===
Source: uhd
Section: science
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               dh-python,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libdpdk-dev (>=20) [amd64 arm64 ppc64el],
               libgps-dev,
               libncurses-dev,
               liborc-0.4-dev,
               libudev-dev [linux-any],
               libusb-1.0-0-dev [linux-any hurd-i386],
               libusb2-dev [kfreebsd-any],
               ninja-build,
               python3-dev,
               python3-mako,
               python3-numpy,
               python3-numpy-dev,
               python3-requests,
	       python3-ruamel.yaml,
               python3-setuptools
Build-Depends-Indep: doxygen,
		     doxygen-latex,
		     graphviz [!powerpcspe]
Standards-Version: 4.7.2
Homepage: https://www.ettus.com/sdr-software/uhd-usrp-hardware-driver/
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-uhd
Vcs-Git: https://salsa.debian.org/bottoms/pkg-uhd.git

Package: uhd-host
Architecture: any
Depends: libuhd4.9.0 (= ${binary:Version}),
         python3-requests,
	 python3-uhd,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: curl, procps
Suggests: fdisk, gnuradio
Description: universal hardware driver for Ettus Research products - host apps
 Host utilities for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package includes the uhd_find_devices application to locate and
 configure attached peripherals, the uhd_usrp_probe application to
 display hardware configuration information and Doxygen generated
 documentation.

Package: libuhd4.9.0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: uhd-host
Multi-Arch: same
Description: universal hardware driver for Ettus Research products - library
 Host library for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.

Package: libuhd4.9.0-dpdk
Architecture: amd64 arm64 ppc64el
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: uhd-host
Conflicts: libuhd4.9.0
Replaces: libuhd4.9.0
Provides: libuhd4.9.0
Multi-Arch: same
Description: universal hardware driver for Ettus Research products - DPDK
 Host library for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package is built with the Data Plane Development Kit and has additional
 dependencies and system configuration requirements to use those features.

Package: libuhd4.9.0-dpdk-tests
Architecture: amd64 arm64 ppc64el
Depends: libuhd4.9.0-dpdk (= ${binary:Version}),
         ${misc:Depends}, ${shlibs:Depends}
Description: universal hardware driver for Ettus Research products - DPDK tests
 Network tests for the Universal Hardware Driver for Ettus Research products.
 .
 This package is built with the Data Plane Development Kit and has additional
 dependencies and system configuration requirements to use those features.

Package: libuhd-dev
Architecture: any
Section: libdevel
Depends: libuhd4.9.0 (= ${binary:Version}), ${misc:Depends}
Recommends: gnuradio-dev, uhd-rfnoc-dev
Suggests: uhd-doc
Multi-Arch: same
Description: universal hardware driver for Ettus Research products - headers
 Host library for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package contains the header files for developing with libuhd.
 Doxygen generated documentation is in the uhd-doc package.

Package: python3-uhd
Architecture: any
Section: python
Depends: libuhd4.9.0 (= ${binary:Version}),
         python3-ruamel.yaml,
	 python3-numpy,
         ${python3:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gnuradio
Breaks: uhd-host (<< 4.5.0.0)
Description: universal hardware driver for Ettus Research products - Python3
 Host library for the Universal Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package contains the Python API support for Python3.

Package: uhd-rfnoc-dev
Architecture: all
Section: libdevel
Depends: python3, ${misc:Depends}
Recommends: libuhd-dev
Suggests: uhd-doc
Multi-Arch: foreign
Description: universal hardware driver for Ettus Research products - rfnoc-dev
 RFNOC development for the Universal Hardware Driver for Ettus
 Research products.
 .
 This package contains fpga definition files for developing with libuhd-dev.

Package: uhd-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-mathjax
Breaks: uhd-host (<< 4.0.0.0-3)
Replaces: uhd-host (<< 4.0.0.0)
Description: universal hardware driver for Ettus Research products - doc
 Detailed documentation for the Universal Hardware Driver.
 .
 This package includes the Doxygen generated documentation.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
py3default = $(subst .,,$(shell py3versions -dv))
HAS_LIBDPDK_DEV=$(shell if [ -f /usr/include/dpdk/rte_version.h ] ; then echo "YES" ;  else echo "NO" ; fi)
DEB_NEON_SIMD_OPTION=$(shell if [ $(DEB_BUILD_ARCH) = armhf ]; then echo "-DNEON_SIMD_ENABLE=OFF" ; else echo "" ; fi)
DEB_UHD_PACKAGE_CONFIGURATION=$(shell echo "-DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_CXX_FLAGS_RELWITHDEBINFO=\"\" \
			     -DENABLE_STATIC_LIBS=OFF -DENABLE_RFNOC_DEV=ON -DENABLE_MANUAL=ON  \
			     -DUHD_VERSION=$(DEB_VERSION) -DENABLE_PYTHON_API=ON \
			     -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python3 \
			     -DBOOST_PYTHON_COMPONENT=python$(py3default) \
	                     -DPKG_LIB_DIR="/usr/libexec/uhd" $(DEB_NEON_SIMD_OPTION)")

ifneq (,$(filter $(DEB_HOST_ARCH), mipsel))
  export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif

%:
	dh $@ --sourcedirectory=host --with python3 --with numpy3 --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure $@ -- $(DEB_UHD_PACKAGE_CONFIGURATION) -DENABLE_DOXYGEN=ON -DENABLE_LATEX_DOCS=OFF \
						-DENABLE_DOXYGEN_DOT=ON -DDOXYGEN_HAVE_DOT=True
	if [ $(HAS_LIBDPDK_DEV) = YES ] ; then dh_auto_configure $@ --builddirectory=uhdplain -- \
				$(DEB_UHD_PACKAGE_CONFIGURATION) -DENABLE_DOXYGEN=OFF -DENABLE_DPDK=OFF ; fi

override_dh_auto_build-arch:
	dh_auto_build $@
	if [ $(HAS_LIBDPDK_DEV) = YES ] ; then dh_auto_build $@ --builddirectory=uhdplain ; fi

override_dh_auto_build-indep:
	dh_auto_build $@

override_dh_auto_test-arch:
	echo "Some tests expected to fail in 4.9.0.0~rc*"
	- dh_auto_test

override_dh_auto_test-indep:
	echo "Not testing - docs only build"

override_dh_auto_install:
	- cp debian/uhd-host.limits debian/uhd-host/etc/security/limits.d/uhd.conf
	- cp debian/uhd-host.sysctl debian/uhd-host/usr/lib/sysctl.d/50-uhd-usrp2.conf
	dh_auto_install $@
	- mv debian/tmp/usr/bin/usrp_hwd.py debian/tmp/usr/bin/usrp_hwd
	- if [ $(HAS_LIBDPDK_DEV) = YES ] ; then \
		dh_auto_install $@ --builddirectory=uhdplain --destdir=debian/tmp/plain ;\
		mv debian/tmp/plain/usr/bin/usrp_hwd.py debian/tmp/plain/usr/bin/usrp_hwd ;\
		mkdir -p debian/tmp/dpdk/usr/lib ;\
		mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) debian/tmp/dpdk/usr/lib/$(DEB_HOST_MULTIARCH) ;\
		rm -rf debian/tmp/dpdk/usr/lib/$(DEB_HOST_MULTIARCH)/cmake ;\
		rm debian/tmp/dpdk/usr/lib/$(DEB_HOST_MULTIARCH)/libuhd.so ;\
		rm -rf debian/tmp/dpdk/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig ;\
		mv debian/tmp/plain/usr/lib/$(DEB_HOST_MULTIARCH) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) ;\
		mkdir -p debian/tmp/dpdk/usr/bin ;\
		mv debian/tmp/usr/libexec/uhd/tests/dpdk_test debian/tmp/dpdk/usr/bin/dpdk_test ;\
		mv debian/tmp/usr/libexec/uhd/tests/dpdk_port_test debian/tmp/dpdk/usr/bin/dpdk_port_test ;\
	fi
	rm -rf debian/tmp/usr/share/doc/uhd/LICENSE
	- find debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/x400 -type d -empty -delete
	rm -rf debian/uhd-host/usr/libexec/uhd/tests/dpdk*
        # Remove source files used to generate documentation
	rm -rf debian/tmp/usr/share/doc/uhd/doxygen/latex
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/export/x300/radio/setupenv.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/rfnoc/crossbar/synth/axis_ctrl_crossbar_nxn_top.tcl
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/rfnoc/crossbar/synth/chdr_crossbar_nxn_top.tcl
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/tools/scripts/git-hash.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/tools/scripts/launch_modelsim.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/tools/scripts/launch_vcom.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/tools/scripts/launch_vivado.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/tools/scripts/setupenv_base.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/tools/scripts/shared-ip-loc-manage.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/e31x/setupenv.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/e320/setupenv.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/n3xx/setupenv.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/python/batch-build
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/x300/setupenv.sh
	chmod +x debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/x400/setupenv.sh
	rm -f debian/*/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/LICENSE.md
	rm -f debian/tmp/usr/libexec/uhd/utils/uhd-usrp.rules
	# install UTF-8 instead of ISO-8859 encoding
	iconv -f ISO-8859-1 -t utf8 debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/zpu/wishbone/wishbone_pkg.vhd > wishbone_pkg.vhd.new
	mv -f wishbone_pkg.vhd.new debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/zpu/wishbone/wishbone_pkg.vhd
	iconv -f ISO-8859-1 -t utf8 debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/zpu/wishbone/zpu_system.vhd > zpu_system.vhd.new
	mv -f zpu_system.vhd.new debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/zpu/wishbone/zpu_system.vhd
	iconv -f ISO-8859-1 -t utf8 debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/zpu/wishbone/zpu_wb_bridge.vhd > zpu_wb_bridge.vhd.new
	mv -f zpu_wb_bridge.vhd.new debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/lib/zpu/wishbone/zpu_wb_bridge.vhd
	iconv -f ISO-8859-1 -t utf8 debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/x400/rf/400m/adc_gearbox_2x4.vhd > adc_gearbox_2x4.vhd.new
	mv -f adc_gearbox_2x4.vhd.new debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/x400/rf/400m/adc_gearbox_2x4.vhd
	iconv -f ISO-8859-1 -t utf8 debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/x400/rf/400m/dac_gearbox_12x8.vhd > dac_gearbox_12x8.vhd
	mv -f dac_gearbox_12x8.vhd debian/tmp/usr/share/uhd/4.9.0/rfnoc/fpga/usrp3/top/x400/rf/400m/dac_gearbox_12x8.vhd

override_dh_shlibdeps:
	dh_shlibdeps --package=uhd-host --libpackage=libuhd4.9.0
	dh_shlibdeps --package=libuhd4.9.0 --libpackage=libuhd4.8.0
	dh_shlibdeps --package=libuhd4.9.0-dpdk --libpackage=libuhd4.8.0-dpdk
	dh_shlibdeps --package=libuhd4.9.0-dpdk-tests --libpackage=libuhd4.8.0-dpdk
	dh_shlibdeps --package=libuhd-dev --libpackage=libuhd4.9.0
	dh_shlibdeps --package=python3-uhd --libpackage=libuhd4.9.0

override_dh_auto_clean:
	rm -rf host/tests/__pycache__
	rm -rf host/tests/common/chdr_resource/__pycache__
	rm -rf host/utils/__pycache__
	rm -rf uhdplain
	dh_auto_clean $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%,\
 repacksuffix=+ds1,repack,dversionmangle=s/\+ds*$//,uversionmangle=tr%-rc%~rc%" \
 https://github.com/EttusResearch/uhd/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
